---
title: XRInputSourceEvent.frame
slug: Web/API/XRInputSourceEvent/frame
tags:
  - API
  - AR
  - Input Sources
  - Inputs
  - Mixed
  - Property
  - Read-only
  - Reality
  - Reference
  - VR
  - Virtual
  - WebXR
  - WebXR API
  - WebXR Device API
  - XR
  - XRInputSourceEvent
  - augmented
  - events
---
<p>{{APIRef("WebXR Device API")}} {{SecureContext_Header}}</p>

<p><span class="seoSummary">The read-only {{domxref("XRInputSourceEvent")}} property <code><strong>frame</strong></code> specifies an {{domxref("XRFrame")}} object representing the event frame during which a <a href="/en-US/docs/Web/API/WebXR_Device_API">WebXR</a> user input occurred.</span> This may thus be an event which occurred in the past rather than a current or impending event.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">let <em>inputFrame</em> = <em>xrInputSourceEvent</em>.frame;</pre>

<h3 id="Value">Value</h3>

<p>An {{domxref("XRFrame")}} indicating the event frame at which the user input event described by the object took place.</p>

<h2 id="Usage_notes">Usage notes</h2>

<p>The event frame does not correspond to a visual frame as is delivered to the frame rendering callback function (see <a href="/en-US/docs/Web/API/WebXR_Device_API/Rendering">Rendering and the WebXR frame rendering callback</a> for details on the callback). Instead, the <code>XRFrame</code> specified by the <code>frame</code> property is a method to provide access to the {{domxref("XRFrame.getPose", "getPose()")}} method, which you can use to get the relative positions of the objects in the scene at the time the event occurred.</p>

<p>However, since the event frame isn't an animation frame, there is no viewer pose available to represent the viewer's current point of view; the results of calling {{domxref("XRFrame.getViewerPose", "getViewerPose()")}} will be an  {{domxref("XRViewerPose")}} with an empty {{domxref("XRViewerPose.views", "views")}} list.</p>

<h2 id="Examples">Examples</h2>

<p>This code shows a handler for the {{domxref("XRSession.selectstart_event", "selectstart")}} event which gets the target ray's pose from the frame, mapping the pose representing the ray (<code>event.inputSource.targetRaySpace</code>) to the overall reference space <code>myRefSpace</code>.</p>

<p>Then, if the result isn't <code>null</code>, the target ray pose's transform is passed into a function called <code>myCheckAndHandleHit()</code> to see if the ray was pointing at anything when the select was triggered.</p>

<pre class="brush: js">xrSession.onselectstart = event =&gt; {
  let targetRayPose = event.frame.getPose(event.inputSource.targetRaySpace,
                            myRefSpace);
  if (targetRayPose) {
    checkAndHandleHit(targetRayPose.transform);
  }
};
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("WebXR","#dom-xrinputsourceevent-frame","XRInputSourceEvent.frame")}}</td>
   <td>{{Spec2("WebXR")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>{{Compat("api.XRInputSourceEvent.frame")}}</div>
